'============================================================================
'  Name     |  Base                                                         |
'  Author   |  IKAR LLC.                                                    |
'  Version  |  1.0                                                          |
'============================================================================


$ifndef mod_Base
$define mod_Base


'----------------------------------- CRLF -----------------------------------
$define ___(P1)                 P1'

'--------------------------------- Ptr Size ---------------------------------
$define Ptr_16                  _code <= 65536
$define Ptr_32                  _code >  65536

'----------------------------------------------------------------------------
$if Ptr_16
    $define Ptr_Size            2
    $define Ptr_Var             Word
    $define Ptr_TBL             Word
$else
    $define Ptr_Size            4
    $define Ptr_Var             Dword
    $define Ptr_TBL             Long
$endif
    
'--------------------------------- MemAlloc ---------------------------------
$ifndef BaseMem
$define BaseMem                 $400
$endif
$define BankMem()               (((BaseMem - 1) >> 8) + 1) * $100

'----------------------------------------------------------------------------
$ifndef True
$define True                    $eval 1
$endif
$ifndef False
$define False                   $eval 0
$endif

'----------------------------------------------------------------------------
$if 0 = 1
$define BOOTLDR
$endif


'-------------------------------- System byte -------------------------------
' Use very carefully, since these are the variables for the proton.
Dim PPZ     As Byte System
Dim PPZH    As Byte System
Dim PPZHH   As Byte System
Dim PPZHHH  As Byte System
Dim PP0     As Byte System
Dim PP0H    As Byte System
Dim PP0HH   As Byte System
Dim PP0HHH  As Byte System
Dim PP1     As Byte System
Dim PP1H    As Byte System
Dim PP1HH   As Byte System
Dim PP1HHH  As Byte System
Dim PP2     As Byte System
Dim PP2H    As Byte System
Dim PP2HH   As Byte System
Dim PP2HHH  As Byte System
Dim PP3     As Byte System
Dim PP3H    As Byte System
Dim PP4     As Byte System

Dim DPPZ    As PPZ.Dword
Dim DPP0    As PP0.Dword
Dim DPP1    As PP1.Dword
Dim DPP2    As PP2.Dword
Dim WPP3    As PP3.Word

Dim PB0     As DPP2.Byte0
Dim PB1     As DPP2.Byte1
Dim PB2     As DPP2.Byte2
Dim PB3     As DPP2.Byte3
Dim PZ0     As DPPZ.Byte0
Dim PZ1     As DPPZ.Byte1
Dim PZ2     As DPPZ.Byte2
Dim PZ3     As DPPZ.Byte3
Dim PL0     As PP4.0
Dim PL1     As PP4.1
Dim PL2     As PP4.2
Dim PL3     As PP4.3
Dim PL4     As PP4.4
Dim PL5     As PP4.5
Dim PL6     As PP4.6
Dim PL7     As PP4.7

'-------------------------------- System alias ------------------------------
Dim FSR0    As Word At FSR0L
Dim FSR1    As Word At FSR1L
Dim FSR2    As Word At FSR2L
Dim PROD    As Word At PRODL
Dim TBLPTR  As Word At TBLPTRL
Dim TBLPTRF As TBLPTRL.Long
Dim TBLPTRA As TBLPTRL.Ptr_TBL
Dim EEADDR  As EEADR.Word


'----------------------------------------------------------------------------
$define Num16_Var(P1,P2)        Movlw ((P1 >> 8)  & 0xFF) : Movwf (P2+1) : Movlw (P1 & 0xFF) : Movwf (P2)
$define Num24_Var(P1,P2)        Movlw ((P1 >> 16) & 0xFF) : Movwf (P2+2) : Num16_Var(P1,P2)
$define Num_TBL(P1)             Num24_Var(P1,TBLPTRL)

'----------------------------------------------------------------------------
$define Optional(P1)            , P1
$define Eval(P1)                $eval P1
$define AsmB                    ___ Asm-    ___
$define AsmE                    ___ EndAsm- ___
$define Asm1(P1)                AsmB    P1          AsmE
$define Asm2(P1,P2)             AsmB    P1,P2       AsmE
$define Asm3(P1,P2,P3)          AsmB    P1,P2,P3    AsmE
$define BRT_(P1)                ((Xtal * 2500000) / (P1) - 5) / 10
$define BIT_(P1)                $eval (1 << P1)
$define GIE                     INTCONbits_GIE

'----------------------------------------------------------------------------
$define Read_Timer(P1,P2)       P2.LowByte = TMR##P1##L   :  P2.HighByte = TMR##P1##H
$define Write_Timer(P1,P2)      TMR##P1##H = P2.HighByte  :  TMR##P1##L  = P2.LowByte

'----------------------------------------------------------------------------
$define ORG_New()               ___($ifndef ORG_LBL) ___($defeval ORG_LBL 0) ___($endif) ___($defeval ORG_LBL $eval ORG_LBL+1)
$define ORG_Begin(P1)           AsmB    ORG_New ___ ORG_PREV##ORG_LBL equ $ ___ Org P1 +0     AsmE
$define ORG_Addr(P1)            AsmB    Org P1                                                AsmE
$define ORG_End                 AsmB    Org ORG_PREV##ORG_LBL                                 AsmE

'----------------------------------------------------------------------------
$define Loop_Djnz(P1,P2)        Declare Reminders = Off  :  Djnz P1,P2  :  Declare Reminders = On


'----------------------------------------------------------------------------
Set_FSR0    Macro P1    ___ #if (Prm_Count != 0) : Lfsr 0, (P1) : #endif    ___ Endm
Set_FSR1    Macro P1    ___ #if (Prm_Count != 0) : Lfsr 1, (P1) : #endif    ___ Endm
Set_FSR2    Macro P1    ___ #if (Prm_Count != 0) : Lfsr 2, (P1) : #endif    ___ Endm


'---------------------------------------------- Help Data Types ---------------------------------------------------------
'LOCAL PRM_EMPTY=0, BIT=1, BYTE=2, WORD=3, DWORD=4, FLOAT=5, LABEL=6, CHAR=7, STRING=9
'LOCAL NUM8=8, NUM16=16, NUM32=32, SNUM8=10, SNUM16=15, SNUM32=31, FNUM=33, BYTE_ARRAY_PTR=22, WORD_ARRAY_PTR=23, DWORD_ARRAY_PTR=24
'LOCAL SBYTE=11, SWORD=12, SDWORD=13, SBYTE_ARRAY_PTR=25, SWORD_ARRAY_PTR=26, SDWORD_ARRAY_PTR=27, LONG=29, LONG_ARRAY_PTR=32

$endif
