'============================================================================
'  Name     |  LCD Driver Pack      ( Monochrome display )                  |
'  Author   |  IKAR LLC.                                                    |
'  Version  |  2.0                                                          |
'============================================================================


'****************************************************************************
___($ifdef LCD_USE_SH1106_128_64)   ___($define mod_LCD_MONO_DETECT)     ___($endif)
___($ifdef LCD_USE_SSD1306_128_64)  ___($define mod_LCD_MONO_DETECT)     ___($endif)
___($ifdef LCD_USE_SSD1306_128_32)  ___($define mod_LCD_MONO_DETECT)     ___($endif)
___($ifdef LCD_USE_SSD1306_64_32)   ___($define mod_LCD_MONO_DETECT)     ___($endif)
___($ifdef LCD_USE_ST7565)          ___($define mod_LCD_MONO_DETECT)     ___($endif)
___($ifdef LCD_USE_HX1230)          ___($define mod_LCD_MONO_DETECT)     ___($endif)
___($ifdef LCD_USE_NOK5110)         ___($define mod_LCD_MONO_DETECT)     ___($endif)


'----------------------------------------------------------------------------
$if 0
$define LCD_USE_SH1106_128_64
$define LCD_USE_SSD1306_128_64
$define LCD_USE_SSD1306_128_32
$define LCD_USE_SSD1306_64_32
$define LCD_USE_ST7565
$define LCD_USE_HX1230
$define LCD_USE_NOK5110
$else
$define LCD_SH1106_128_64           1
$define LCD_SSD1306_128_64          2
$define LCD_SSD1306_128_32          3
$define LCD_SSD1306_64_32           4
$define LCD_ST7565                  13
$define LCD_HX1230                  14
$define LCD_NOK5110                 15
$endif


'----------------------------------------------------------------------------
$ifdef mod_LCD_MONO_DETECT
    $define LCD_SZNEW(P1,P2)        $eval P1 * ((P2 + 7) & (~7)) / 8
    $define LCD_SIZE                0
    
    $if _defined(LCD_USE_NOK5110)
        ___($define LCD_SZTMP()     LCD_SZNEW(84,48))  ___  ___($if LCD_SZTMP > LCD_SIZE) ___($defeval LCD_SIZE  LCD_SZTMP) ___($endif)
    $endif

    $if _defined(LCD_USE_HX1230)
        ___($define LCD_SZTMP()     LCD_SZNEW(96,68))  ___  ___($if LCD_SZTMP > LCD_SIZE) ___($defeval LCD_SIZE  LCD_SZTMP) ___($endif)
    $endif
    
    $if _defined(LCD_USE_ST7565)
        ___($define LCD_SZTMP()     LCD_SZNEW(128,64))  ___  ___($if LCD_SZTMP > LCD_SIZE) ___($defeval LCD_SIZE  LCD_SZTMP) ___($endif)
    $endif

    $if _defined(LCD_USE_SSD1306_64_32)
        $define LCD_USE_SSD1306
        ___($define LCD_SZTMP()     LCD_SZNEW(64,32))  ___  ___($if LCD_SZTMP > LCD_SIZE) ___($defeval LCD_SIZE  LCD_SZTMP) ___($endif)
    $endif

    $if _defined(LCD_USE_SSD1306_128_32)
        $define LCD_USE_SSD1306
        ___($define LCD_SZTMP()     LCD_SZNEW(128,32)) ___  ___($if LCD_SZTMP > LCD_SIZE) ___($defeval LCD_SIZE  LCD_SZTMP) ___($endif)
    $endif
                
    $if _defined(LCD_USE_SSD1306_128_64) Or _defined(LCD_USE_SH1106_128_64)
        $define LCD_USE_SSD1306
        ___($define LCD_SZTMP()     LCD_SZNEW(128,64)) ___  ___($if LCD_SZTMP > LCD_SIZE) ___($defeval LCD_SIZE  LCD_SZTMP) ___($endif)
    $endif
$endif


'****************************************************************************
$if _defined(mod_LCD_MONO_DETECT) And !_defined(mod_LCD_MONO_DRV)
$define mod_LCD_MONO_DRV

'----------------------------------------------------------------------------
Include "Lib\LCD\LCD_DEF.inc"


'--------------------------------- NOK5110 ----------------------------------
$define NOK5110_FUNC_EXT                $21
$define NOK5110_FUNC                    $20
$define NOK5110_EXT                     $01
$define NOK5110_ENTRYMODE               $02
$define NOK5110_POWERDOWN               $04
$define NOK5110_DISPLAY                 $08
$define NOK5110_BLANK                   $00
$define NOK5110_ALLON                   $01
$define NOK5110_NORMAL                  $04
$define NOK5110_INVERT                  $05
$define NOK5110_ADDR_Y                  $40
$define NOK5110_ADDR_X                  $80
$define NOK5110_TEMP                    $04
$define NOK5110_BIAS                    $10
$define NOK5110_VOP                     $80

'--------------------------------- SSD1306 ----------------------------------
$define SSD1306_ADDR                    $78
$define SSD1306_CONTRAST                $81
$define SSD1306_RAM_OFF                 $A5
$define SSD1306_INVERT_OFF              $A6
$define SSD1306_INVERT_ON               $A7
$define SSD1306_RAM_ON                  $A4
$define SSD1306_SCROLL_OFF              $2E
$define SSD1306_NOP                     $E3
$define SSD1306_ADDR_COL_L              $00
$define SSD1306_ADDR_COL_H              $10
$define SSD1306_ADDR_MODE               $20
$define SSD1306_ADDR_COLUMN             $21
$define SSD1306_ADDR_PAGE               $22
$define SSD1306_ADDR_ONE                $B0
$define SSD1306_REMAP_R_L               $A0
$define SSD1306_REMAP_L_R               $A1
$define SSD1306_MULTI_RATIO             $A8
$define SSD1306_REMAP_D_T               $C0
$define SSD1306_REMAP_T_D               $C8
$define SSD1306_DISP_OFFSET             $D3
$define SSD1306_COM_PINS                $DA
$define SSD1306_DISPLAY_CLOCK           $D5
$define SSD1306_PRECHARGE_PRD           $D9
$define SSD1306_VCOM_DESELECT           $DB
$define SSD1306_CHARGE_DC_PUMP          $8D
$define SSD1306_SHIFT_DC                $40
$define SSD1306_SHIFT_CO                $80

'---------------------------------- ST7565 ----------------------------------
$define ST7565_BOOSTER_FIRST            $F8
$define ST7565_BOOSTER_234              0
$define ST7565_BOOSTER_5                1
$define ST7565_BOOSTER_6                3
$define ST7565_CONTRAST_ARG             0
$define ST7565_BIAS_9                   $A2
$define ST7565_ALLPTS_NORMAL            $A4
$define ST7565_POWER_CONTROL            $28
$define ST7565_RESISTOR_RATIO           $20

'---------------------------------- Common ----------------------------------
$define COM_DISPLAY_OFF                 $AE
$define COM_DISPLAY_ON                  $AF
$define COM_START_LINE                  $40
$define COM_RESET                       $E2


'=================================== Code ===================================
GoTo Over_LCD_MONO_DRV


'----------------------------------------------------------------------------
$ifdef LCD_USE_NOK5110
    TBL_New(_NOK5110_)
        TBL_Raw(LCD_T_MAIN)     CData Word 84, Word 48, LCD_INI(0, 0, 0)
        TBL_Raw(LCD_T_LIST)     CData NOK5110_FUNC_EXT,              0,                                 _
                                NOK5110_VOP  | 62,                   0,                                 _
                                NOK5110_TEMP | 2,                    0,                                 _
                                NOK5110_BIAS | 4,                    0,                                 _
                                NOK5110_FUNC,                        0,                                 _
                                NOK5110_DISPLAY | NOK5110_NORMAL,    0
    TBL_End
$endif
'----------------------------------------------------------------------------


'----------------------------------------------------------------------------    
$ifdef LCD_USE_HX1230
    TBL_New(_HX1230_)
        TBL_Raw(LCD_T_MAIN)     CData Word 96, Word 68, LCD_INI(0, 0, 0)
        TBL_Raw(LCD_T_LIST)     CData COM_RESET,            0,                                          _  ' reset
                                COM_DISPLAY_OFF,            0,                                          _  ' display off
                                $20,                        0,                                          _  ' power off
                                NOK5110_VOP | 16,           0,                                          _  ' contrast setting, 0..31, set to 0
                                SSD1306_INVERT_OFF,         0,                                          _  ' not inverted display
                                $A4,                        0,                                          _  ' normal display mode
                                SSD1306_REMAP_R_L,          0,                                          _  '
                                SSD1306_REMAP_D_T,          0,                                          _  '
                                COM_START_LINE,             0,                                          _  ' start at scanline 0
                                $2F,                        0,                                          _  ' power on
                                COM_DISPLAY_ON,             0                                              ' display on
    TBL_End
$endif
'----------------------------------------------------------------------------


'----------------------------------------------------------------------------    
$ifdef LCD_USE_ST7565
    TBL_New(_ST7565_)
        TBL_Raw(LCD_T_MAIN)     CData Word 128, Word 64, LCD_INI(0, 0, 0)
        TBL_Raw(LCD_T_OFFS)     CData 0, 0,   0, 0,   4, 0,   4, 0
        TBL_Raw(LCD_T_LIST)     CData COM_RESET,                0,                                      _
                                COM_DISPLAY_OFF,                0,                                      _
                                COM_START_LINE,                 0,                                      _
                                SSD1306_REMAP_R_L,              0,                                      _
                                SSD1306_REMAP_D_T,              0,                                      _
                                ST7565_BIAS_9,                  0,                                      _
                                ST7565_POWER_CONTROL  | 7,      0,                                      _
                                ST7565_BOOSTER_FIRST,           0,                                      _
                                ST7565_BOOSTER_234,             0,                                      _
                                ST7565_RESISTOR_RATIO | 7,      0,                                      _
                                SSD1306_CONTRAST,               0,                                      _
                                ST7565_CONTRAST_ARG | 14,       0,                                      _
                                ST7565_ALLPTS_NORMAL,           0,                                      _
                                COM_DISPLAY_ON,                 0
    TBL_End
$endif
'----------------------------------------------------------------------------


'----------------------------------------------------------------------------    
$ifdef LCD_USE_SSD1306
    TBL_New(_SSD1306_)
        TBL_Raw(LCD_T_MAIN)     CData Word 128, Word 64, LCD_INI(0, SSD1306_ADDR, 0)
        TBL_Raw(LCD_T_LIST)     CData SSD1306_NOP,            LCD_L_CMD + 26,                           _
                                COM_DISPLAY_OFF,                                                        _
                                SSD1306_DISPLAY_CLOCK,        $80,                                      _
                                SSD1306_MULTI_RATIO,          $3F,                                      _
                                SSD1306_DISP_OFFSET,          $00,                                      _
                                COM_START_LINE,                                                         _
                                SSD1306_CHARGE_DC_PUMP,       $14,                                      _
                                SSD1306_ADDR_MODE,            $00,                                      _
                                SSD1306_REMAP_L_R,                                                      _
                                SSD1306_REMAP_T_D,                                                      _
                                SSD1306_COM_PINS,             $12,                                      _
                                SSD1306_CONTRAST,             $CF,                                      _
                                SSD1306_PRECHARGE_PRD,        $F1,                                      _
                                SSD1306_VCOM_DESELECT,        $40,                                      _
                                SSD1306_SCROLL_OFF,                                                     _
                                SSD1306_RAM_ON,                                                         _
                                SSD1306_INVERT_OFF,                                                     _
                                COM_DISPLAY_ON
    TBL_End
$endif

$ifdef LCD_USE_SSD1306_128_64
    TBL_New(_SSD1306_128_64_)
        TBL_Ptr(LCD_T_MAIN)     _SSD1306_
        TBL_Ptr(LCD_T_LIST)     _SSD1306_
    TBL_End
$endif

$ifdef LCD_USE_SH1106_128_64
    TBL_New(_SH1106_128_64_)
        TBL_Ptr(LCD_T_MAIN)     _SSD1306_
        TBL_Ptr(LCD_T_LIST)     _SSD1306_
        TBL_Raw(LCD_T_LIST)     CData SSD1306_NOP, LCD_L_CMD + 2, SSD1306_PRECHARGE_PRD, $1F
        TBL_Raw(LCD_T_OFFS)     CData $02, $00
    TBL_End
$endif

$ifdef LCD_USE_SSD1306_128_32
    TBL_New(_SSD1306_128_32_)
        TBL_Ptr(LCD_T_MAIN)     _SSD1306_
        TBL_Ptr(LCD_T_LIST)     _SSD1306_
        TBL_Raw(LCD_T_MAIN)     CData Word 128, Word 32
        TBL_Raw(LCD_T_LIST)     CData SSD1306_NOP, LCD_L_CMD + 4, SSD1306_MULTI_RATIO, $1F, SSD1306_COM_PINS, $02
    TBL_End
$endif

$ifdef LCD_USE_SSD1306_64_32
    TBL_New(_SSD1306_64_32_)
        TBL_Ptr(LCD_T_MAIN)     _SSD1306_
        TBL_Ptr(LCD_T_LIST)     _SSD1306_
        TBL_Raw(LCD_T_MAIN)     CData Word 64, Word 32
        TBL_Raw(LCD_T_LIST)     CData SSD1306_NOP, LCD_L_CMD + 2, SSD1306_MULTI_RATIO, $1F
        TBL_Raw(LCD_T_OFFS)     CData $20, $00
    TBL_End
$endif
'----------------------------------------------------------------------------


'----------------------------------------------------------------------------
Proc LCD_Select(value As WREG)
    If WREG <> 0 Then Lcd_ID = WREG
    
    TBLPTRA = 0

    ___($ifdef LCD_USE_SH1106_128_64 )    ___(If Lcd_ID = LCD_SH1106_128_64   Then TBLPTRA = _SH1106_128_64_   :  ExitProc)    ___($endif)
    ___($ifdef LCD_USE_SSD1306_128_64)    ___(If Lcd_ID = LCD_SSD1306_128_64  Then TBLPTRA = _SSD1306_128_64_  :  ExitProc)    ___($endif)
    ___($ifdef LCD_USE_SSD1306_128_32)    ___(If Lcd_ID = LCD_SSD1306_128_32  Then TBLPTRA = _SSD1306_128_32_  :  ExitProc)    ___($endif)
    ___($ifdef LCD_USE_SSD1306_64_32 )    ___(If Lcd_ID = LCD_SSD1306_64_32   Then TBLPTRA = _SSD1306_64_32_   :  ExitProc)    ___($endif)
    ___($ifdef LCD_USE_ST7565        )    ___(If Lcd_ID = LCD_ST7565          Then TBLPTRA = _ST7565_          :  ExitProc)    ___($endif)
    ___($ifdef LCD_USE_HX1230        )    ___(If Lcd_ID = LCD_HX1230          Then TBLPTRA = _HX1230_          :  ExitProc)    ___($endif)
    ___($ifdef LCD_USE_NOK5110       )    ___(If Lcd_ID = LCD_NOK5110         Then TBLPTRA = _NOK5110_         :  ExitProc)    ___($endif)

EndProc


'****************************************************************************
Over_LCD_MONO_DRV:

$endif
