'============================================================================
'  Name     |  LCD Driver Pack      ( Color display )                       |
'  Author   |  IKAR LLC.                                                    |
'  Version  |  1.0                                                          |
'============================================================================


'****************************************************************************
___($ifdef LCD_USE_TFT1_350_320_480)    ___($define mod_LCD_TFT_DETECT)     ___($endif)
___($ifdef LCD_USE_TFT2_350_320_480)    ___($define mod_LCD_TFT_DETECT)     ___($endif)
___($ifdef LCD_USE_TFT3_350_320_480)    ___($define mod_LCD_TFT_DETECT)     ___($endif)
___($ifdef LCD_USE_TFT_280_240_320)     ___($define mod_LCD_TFT_DETECT)     ___($endif)
___($ifdef LCD_USE_TFT_200_240_320)     ___($define mod_LCD_TFT_DETECT)     ___($endif)
___($ifdef LCD_USE_TFT_180_128_160)     ___($define mod_LCD_TFT_DETECT)     ___($endif)
___($ifdef LCD_USE_TFT_177_128_160)     ___($define mod_LCD_TFT_DETECT)     ___($endif)
___($ifdef LCD_USE_TFT_144_128_128)     ___($define mod_LCD_TFT_DETECT)     ___($endif)
___($ifdef LCD_USE_TFT_130_240_240)     ___($define mod_LCD_TFT_DETECT)     ___($endif)
___($ifdef LCD_USE_TFT_114_135_240)     ___($define mod_LCD_TFT_DETECT)     ___($endif)
___($ifdef LCD_USE_TFT_096_80_160)      ___($define mod_LCD_TFT_DETECT)     ___($endif)


'----------------------------------------------------------------------------
$if 0
    $define LCD_USE_TFT1_350_320_480
    $define LCD_USE_TFT2_350_320_480
    $define LCD_USE_TFT3_350_320_480
    $define LCD_USE_TFT_280_240_320
    $define LCD_USE_TFT_200_240_320
    $define LCD_USE_TFT_180_128_160
    $define LCD_USE_TFT_177_128_160
    $define LCD_USE_TFT_144_128_128
    $define LCD_USE_TFT_130_240_240
    $define LCD_USE_TFT_114_135_240
    $define LCD_USE_TFT_096_80_160
$else
    $define LCD_TFT1_350_320_480           1
    $define LCD_TFT2_350_320_480           2
    $define LCD_TFT3_350_320_480           3
    $define LCD_TFT_280_240_320            4
    $define LCD_TFT_200_240_320            5
    $define LCD_TFT_180_128_160            6
    $define LCD_TFT_177_128_160            7
    $define LCD_TFT_144_128_128            8
    $define LCD_TFT_130_240_240            9
    $define LCD_TFT_114_135_240           10
    $define LCD_TFT_096_80_160            11
$endif


'****************************************************************************
$if _defined(mod_LCD_TFT_DETECT) And !_defined(mod_LCD_TFT_DRV)
$define mod_LCD_TFT_DRV


'--------------------------------- Command ----------------------------------
$define LCD_CMD_NOP             $00
$define LCD_CMD_SWRESET         $01
$define LCD_CMD_SLPIN           $10
$define LCD_CMD_SLPOUT          $11
$define LCD_CMD_PTLON           $12
$define LCD_CMD_NORML           $13
$define LCD_CMD_DINVOF          $20
$define LCD_CMD_DINVON          $21
$define LCD_CMD_GAMMASET        $26
$define LCD_CMD_DISPOFF         $28
$define LCD_CMD_DISPON          $29
$define LCD_CMD_IDLEOF          $38
$define LCD_CMD_IDLEON          $39

$define LCD_CMD_CASET           $2A
$define LCD_CMD_RASET           $2B
$define LCD_CMD_RAMWR           $2C
$define LCD_CMD_RAMRD           $2E

$define LCD_CMD_PARTAREA        $30
$define LCD_CMD_VSCLLDEF        $33
$define LCD_CMD_TEFXLOF         $34
$define LCD_CMD_TEFXLON         $35
$define LCD_CMD_MADCTL          $36
$define LCD_CMD_VSSTADRS        $37
$define LCD_CMD_PIXFMT          $3A

$define LCD_CMD_FRMCTR1         $B1
$define LCD_CMD_FRMCTR2         $B2
$define LCD_CMD_FRMCTR3         $B3
$define LCD_CMD_DINVCTR         $B4
$define LCD_CMD_BLPHCTR         $B5
$define LCD_CMD_DFUNCTR         $B6
$define LCD_CMD_GCTRL           $B7
$define LCD_CMD_DGAMMA          $BA
$define LCD_CMD_VCOMS           $BB

$define LCD_CMD_PWCTR1          $C0
$define LCD_CMD_PWCTR2          $C1
$define LCD_CMD_PWCTR3          $C2
$define LCD_CMD_PWCTR4          $C3
$define LCD_CMD_PWCTR5          $C4
$define LCD_CMD_VCOMCTR1        $C5
$define LCD_CMD_VCOMCTR2        $C7

$define LCD_CMD_PGAMMAC         $E0
$define LCD_CMD_NGAMMAC         $E1
$define LCD_CMD_GAMRSEL         $F2

'---------------------------------- Mask ------------------------------------
$define LCD__FV                 $01
$define LCD__FH                 $02
$define LCD__MH                 $04
$define LCD__RGB                $00
$define LCD__BGR                $08
$define LCD__ML                 $10
$define LCD__MV                 $20
$define LCD__MX                 $40
$define LCD__MY                 $80


'=================================== Code ===================================
GoTo Over_LCD_TFT_DRV


'----------------------------------------------------------------------------
$ifdef LCD_USE_TFT1_350_320_480
    TBL_New(_TFT1_350_320_480_)
        TBL_Raw(LCD_T_MAIN)     CData Word 320, Word 480, LCD_INI(0, 0, LCD_CAP_NOPULSE)
        TBL_Raw(LCD_T_ROTN)     CData LCD__FH | LCD__BGR,  LCD__MV | LCD__BGR,  LCD__FV | LCD__BGR,  LCD__FH | LCD__FV | LCD__MV | LCD__BGR
        TBL_Raw(LCD_T_LIST)     CData LCD_CMD_IDLEOF,   0,                                                                      _  ' Exit idle mode (ILI9481)
                                $B0,                    1,  $00,                                                                _  ' unlocks E0, F0
                                $B3,                    4,  $02, $00, $00, $00,                                                 _  ' Frame Memory, interface
                                $B4,                    1,  $00,                                                                _  ' Frame mode
                                $D0,                    3,  $07, $42, $18,                                                      _  ' Set Power x1.00, x6, x3
                                $D1,                    3,  $00, $07, $10,                                                      _  ' Set VCOM  x0.72, x1.02
                                $D2,                    2,  $01, $02,                                                           _  ' Set Power for Normal Mode
                                $D3,                    2,  $01, $02,                                                           _  ' Set Power for Partial Mode
                                $D4,                    2,  $01, $02,                                                           _  ' Set Power for Idle Mode
                                $C0,                    5,  $10, $3B, $00, $02, $11,                                            _  ' Set Panel Driving
                                $C1,                    3,  $10, $10, $88,                                                      _  ' Display Timing Normal
                                $C5,                    1,  $03,                                                                _  ' Frame Rate
                                $C6,                    1,  $02,                                                                _  ' Interface Control
                                $C8,                   12,  $00, $32, $36, $45, $06, $16, $37, $75, $77, $54, $0C, $00,         _
                                $CC,                    1,  $00                                                                    ' Panel Control
    TBL_End
$endif
'----------------------------------------------------------------------------


'----------------------------------------------------------------------------
$ifdef LCD_USE_TFT2_350_320_480
    TBL_New(_TFT2_350_320_480_)
        TBL_Raw(LCD_T_MAIN)     CData Word 320, Word 480, LCD_INI(0, 0, LCD_CAP_INVERSE | LCD_CAP_NOPULSE)
        TBL_Raw(LCD_T_ROTN)     CData LCD__MX | LCD__BGR,  LCD__MV | LCD__BGR,  LCD__MY | LCD__BGR,  LCD__MX | LCD__MY | LCD__MV | LCD__BGR
        TBL_Raw(LCD_T_LIST)     CData LCD_CMD_IDLEOF,   0,                                                                      _  ' HX8357D
                                $B9,                    3,  $FF, $83, $57,                                                      _  ' HX8357_ENABLE_EXTENSION_COMMAND
                                $B4,                    7,  $02, $40, $00, $2A, $2A, $0D, $78,                                  _  ' HX8357_SET_DISPLAY_MODE
                                $B6,                    1,  $25,                                                                _  ' HX8357_SET_VCOM_VOLTAGE
                                $C0,                    6,  $50, $50, $01, $3C, $1E, $08,                                       _  ' HX8357_SET_PANEL_DRIVING
                                $E0,                   34,  $02, $0A, $11, $1D, $23, $35, $41, $4B, $4B, $42, $3A, $27,         _  ' HX8357_SET_GAMMA_CURVE
                                                            $1B, $08, $09, $03, $02, $0A, $11, $1D, $23, $35, $41, $4B,         _
                                                            $4B, $42, $3A, $27, $1B, $08, $09, $03, $00, $01
    TBL_End
$endif
'----------------------------------------------------------------------------


'----------------------------------------------------------------------------
$ifdef LCD_USE_TFT3_350_320_480
    TBL_New(_TFT3_350_320_480_)
        TBL_Raw(LCD_T_MAIN)     CData Word 320, Word 480, LCD_INI(0, 0, LCD_CAP_NOPULSE)
        TBL_Raw(LCD_T_ROTN)     CData LCD__MX | LCD__BGR,  LCD__MV | LCD__BGR,  LCD__MY | LCD__BGR,  LCD__MX | LCD__MY | LCD__MV | LCD__BGR
        TBL_Raw(LCD_T_LIST)     CData LCD_CMD_IDLEOF,   0,                                                                      _  ' Exit idle mode (ILI9486)
                                $F2,                    9,  $1C, $A3, $32, $02, $b2, $12, $FF, $12, $00,                        _
                                $F1,                    2,  $36, $A4,                                                           _
                                $F8,                    2,  $21, $04,                                                           _
                                $F9,                    2,  $00, $08,                                                           _
                                $C0,                    2,  $0d, $0d,                                                           _  ' Power Control 1
                                $C1,                    2,  $43, $00,                                                           _  ' Power Control 2
                                $C2,                    1,  $00,                                                                _  ' Power Control 3
                                $C5,                    4,  $00, $48, $00, $48,                                                 _  ' VCOM  Control 1
                                $B6,                    3,  $02, $02, $3B,                                                      _  ' Display Function Control
                                LCD_CMD_FRMCTR1,        2,  $D0, $11,                                                           _  ' Frame Rate Control (In normal mode)
                                LCD_CMD_PGAMMAC,       15,  $0F, $24, $1C, $0A, $0F, $08, $43, $88, $32, $0F, $10, $06, $0F, $07, $00,  _  ' Positive Gamma Correction Setting
                                LCD_CMD_NGAMMAC,       15,  $0F, $38, $30, $09, $0F, $0F, $4E, $77, $3C, $07, $10, $05, $23, $1B, $00      ' Negative Gamma Correction Setting
    TBL_End
$endif
'----------------------------------------------------------------------------


'----------------------------------------------------------------------------
$ifdef LCD_USE_TFT_280_240_320
    TBL_New(_TFT_280_240_320_)
        TBL_Raw(LCD_T_MAIN)     CData Word 240, Word 320, LCD_INI(2, 0, LCD_CAP_NOPULSE)
        TBL_Raw(LCD_T_ROTN)     CData LCD__MX | LCD__BGR,  LCD__MV | LCD__BGR,  LCD__MY | LCD__BGR,  LCD__MV | LCD__MX | LCD__MY | LCD__BGR
        TBL_Raw(LCD_T_LIST)     CData LCD_CMD_IDLEOF,   0,                                                                      _  ' Exit idle mode (ILI9341)
                                LCD_CMD_VCOMCTR1,       2,  $3E, $28,                                                           _  ' VCOM control 1
                                LCD_CMD_VCOMCTR2,       1,  $86,                                                                _  ' VCOM control 1
                                LCD_CMD_DFUNCTR,        3,  $08, $82, $27,                                                      _  ' Display Fuction set 5
                                LCD_CMD_FRMCTR1,        2,  $00, $10,                                                           _  ' Frame Rate Control (In normal mode)
                                LCD_CMD_GAMMASET,       1,  $01,                                                                _  ' Default gamma curve?
                                LCD_CMD_GAMRSEL,        1,  $00,                                                                _  ' Enable Gamma adj ?
                                LCD_CMD_PGAMMAC,       15,  $0F,$31,$2B,$0C,$0E,$08,$4E,$F1,$37,$07,$10,$03,$0E,$09,$00,        _  ' Positive Gamma Correction Setting
                                LCD_CMD_NGAMMAC,       15,  $00,$0E,$14,$03,$11,$07,$31,$C1,$48,$08,$0F,$0C,$31,$36,$0F,        _  ' Negative Gamma Correction Setting
                                LCD_CMD_DINVCTR,        1,  7,                                                                  _  ' Display inversion
                                LCD_CMD_NORML,          0,                                                                      _  ' Display Normal
                                LCD_CMD_PWCTR1,         1,  $23,                                                                _  ' Power Control 1
                                LCD_CMD_PWCTR2,         1,  $10,                                                                _  ' Power Control 2
                                $EF,                    3,  $03, $80, $02,                                                      _
                                $CF,                    3,  $00, $C1, $30,                                                      _
                                $E8,                    3,  $85, $00, $78,                                                      _
                                $ED,                    4,  $64, $03, $12, $81,                                                 _
                                $CB,                    5,  $39, $2C, $00, $34, $02,                                            _
                                $EA,                    2,  $00, $00,                                                           _
                                $F7,                    1,  $20
    TBL_End
$endif
'----------------------------------------------------------------------------


'----------------------------------------------------------------------------
$ifdef LCD_USE_TFT_200_240_320
    TBL_New(_TFT_200_240_320_)
        TBL_Raw(LCD_T_MAIN)     CData Word 240, Word 320, LCD_INI(0, 0, 0)
        TBL_Raw(LCD_T_ROTN)     CData LCD__BGR,  LCD__MX | LCD__MV | LCD__BGR,  LCD__MX | LCD__MY | LCD__BGR,  LCD__MY | LCD__MV | LCD__BGR
        TBL_Raw(LCD_T_LIST)     CData LCD_CMD_IDLEOF,   0,                                                                      _  ' Exit idle mode (ST7789V)
                                LCD_CMD_GCTRL,          1,  $35,                                                                _  ' Voltages: VGH / VGL
                                LCD_CMD_VCOMS,          1,  $28,                                                                _  ' JLX240 display datasheet
                                $B0,                    2,  $00, $E0,                                                           _
                                $B2,                    5,  $0C, $0C, $00, $33, $33,                                            _  ' Porch Setting
                                LCD_CMD_GAMMASET,       1,  $01,                                                                _  ' Default gamma curve?      
                                'LCD_CMD_PGAMMAC,      14,  $D0,$00,$02,$07,$0A,$28,$32,$44,$42,$06,$0E,$12,$14,$17,            _  ' Positive Gamma Correction Setting
                                'LCD_CMD_NGAMMAC,      14,  $D0,$00,$02,$07,$0A,$28,$31,$54,$47,$0E,$1C,$17,$1B,$1E,            _  ' Negative Gamma Correction Setting
                                LCD_CMD_NORML,          0,                                                                      _  ' Display Normal    
                                $C0,                    1,  $1C,                                                                _  ' LCM Control
                                $C2,                    2,  $01, $FF,                                                           _  ' VDV and VRH Enable
                                $C3,                    1,  $10,                                                                _  ' VRH Set
                                $C4,                    1,  $20,                                                                _  ' VDV Set
                                $C6,                    1,  $09,                                                                _  ' Frame Rate Control in Normal Mode
                                $D0,                    2,  $A4, $A1                                                               ' Power control 1
    TBL_End
$endif
'----------------------------------------------------------------------------


'----------------------------------------------------------------------------
$ifdef LCD_USE_TFT_144_128_128
    TBL_New(_TFT_144_128_128_)
        TBL_Raw(LCD_T_MAIN)     CData Word 128, Word 128, LCD_INI(0, 0, 0)
        TBL_Raw(LCD_T_ROTN)     CData LCD__BGR,  LCD__MX | LCD__MV | LCD__BGR,  LCD__MX | LCD__MY | LCD__BGR,  LCD__MY | LCD__MV | LCD__BGR
        TBL_Raw(LCD_T_OFFS)     CData 2, 1,   1, 2,   2, 3,   3, 2                                                                 ' Offset (X0,Y0, X1,Y1, X2,Y2, X3,Y3)
        TBL_Raw(LCD_T_LIST)     CData LCD_CMD_IDLEOF,   0,                                                                      _  ' Exit idle mode (ILI9163C)
                                LCD_CMD_VCOMCTR1,       2,  $24, $48,                                                           _  ' VCOM control 1
                                '$C7,                   1,  $FF,                                                                _  ' VCOM Offset Control
                                LCD_CMD_DFUNCTR,        2,  $3F, $01,                                                           _  ' Display Fuction set 5
                                LCD_CMD_FRMCTR1,        2,  $08, $02,                                                           _  ' Frame Rate Control (In normal mode)
                                LCD_CMD_FRMCTR2,        2,  $08, $02,                                                           _  ' Frame Rate Control (Idle mode/8 Bits)
                                LCD_CMD_FRMCTR3,        2,  $08, $02,                                                           _  ' Frame Rate Control (Partial mode)
                                LCD_CMD_GAMMASET,       1,  $04,                                                                _  ' Default gamma curve?
                                LCD_CMD_GAMRSEL,        1,  $01,                                                                _  ' Enable Gamma adj ?
                                'LCD_CMD_PGAMMAC,      15,  $3F,$26,$23,$30,$28,$10,$55,$B7,$40,$19,$10,$1E,$02,$01,$00,        _  ' Positive Gamma Correction Setting
                                'LCD_CMD_NGAMMAC,      15,  $09,$18,$2D,$0D,$13,$15,$40,$48,$53,$0C,$1D,$25,$2E,$24,$29,        _  ' Negative Gamma Correction Setting
                                LCD_CMD_DINVCTR,        1,  7,                                                                  _  ' Display inversion
                                LCD_CMD_NORML,          0,                                                                      _  ' Display Normal
                                LCD_CMD_PWCTR1,         2,  $1D, $02,                                                           _  ' Power Control 1
                                LCD_CMD_PWCTR2,         1,  $02,                                                                _  ' Power Control 2       
                                LCD_CMD_PWCTR3,         1,  $01,                                                                _  ' Power Control 3
                                LCD_CMD_PWCTR4,         1,  $01,                                                                _  ' Power Control 4 (idle)
                                LCD_CMD_PWCTR5,         1,  $01                                                                    ' Power Control 5 (partial)
    TBL_End
$endif
'----------------------------------------------------------------------------


'----------------------------------------------------------------------------
$ifdef LCD_USE_TFT_180_128_160
    TBL_New(_TFT_180_128_160_)
        TBL_Raw(LCD_T_MAIN)     CData Word 128, Word 160, LCD_INI(2, 0, 0)
        TBL_Raw(LCD_T_ROTN)     CData LCD__RGB,  LCD__MX | LCD__MV | LCD__RGB,  LCD__MX | LCD__MY | LCD__RGB,  LCD__MY | LCD__MV | LCD__RGB
        TBL_Raw(LCD_T_LIST)     CData LCD_CMD_IDLEOF,   0,                                                                      _  ' Exit idle mode
                                LCD_CMD_VCOMCTR1,       2,  $3C, $38,                                                           _  ' ST7735B VCOM control 1
                                LCD_CMD_DFUNCTR,        2,  $15, $02,                                                           _  ' Display Fuction set 5
                                LCD_CMD_FRMCTR1,        3,  $00, $06, $03,                                                      _  ' Frame Rate Control (In normal mode)    
                                LCD_CMD_GAMMASET,       1,  $04,                                                                _  ' Default gamma curve?
                                LCD_CMD_GAMRSEL,        1,  $01,                                                                _  ' Enable Gamma adj ?          
                                'LCD_CMD_PGAMMAC,      16, $09,$16,$09,$20,$21,$1B,$13,$19,$17,$15,$1E,$2B,$04,$05,$02,$OE,     _  ' Positive Gamma Correction Setting
                                'LCD_CMD_NGAMMAC,      16, $0B,$14,$08,$1E,$22,$1D,$18,$1E,$1B,$1A,$24,$2B,$06,$06,$02,$0F,     _  ' Negative Gamma Correction Setting
                                LCD_CMD_DINVCTR,        1,  0,                                                                  _  ' Display inversion
                                LCD_CMD_NORML,          0,                                                                      _  ' Display Normal    
                                LCD_CMD_PWCTR1,         2,  $02, $70,                                                           _  ' Power Control 1
                                LCD_CMD_PWCTR2,         1,  $05,                                                                _  ' Power Control 2
                                LCD_CMD_PWCTR3,         2,  $01, $02,                                                           _  ' Power Control 3
                                $FC,                    2,  $11, $15                                                               ' Power Control 4
    TBL_End
$endif
'----------------------------------------------------------------------------


'----------------------------------------------------------------------------
$ifdef LCD_USE_TFT_177_128_160
    TBL_New(_TFT_177_128_160_)
        TBL_Raw(LCD_T_MAIN)     CData Word 128, Word 160, LCD_INI(2, 0, 0)
        TBL_Raw(LCD_T_ROTN)     CData LCD__RGB,  LCD__MX | LCD__MV | LCD__RGB,  LCD__MX | LCD__MY | LCD__RGB,  LCD__MY | LCD__MV | LCD__RGB
        TBL_Raw(LCD_T_LIST)     CData LCD_CMD_IDLEOF,   0,                                                                      _  ' Exit idle mode (ST7735S)
                                LCD_CMD_FRMCTR1,        3,  $01, $2C, $2D,                                                      _
                                LCD_CMD_FRMCTR2,        3,  $01, $2C, $2D,                                                      _
                                LCD_CMD_FRMCTR3,        6,  $01, $2C, $2D, $01, $2C, $2D,                                       _
                                LCD_CMD_DINVCTR,        1,  $07,                                                                _
                                LCD_CMD_PWCTR1,         3,  $A2, $02, $84,                                                      _
                                LCD_CMD_PWCTR2,         1,  $C5,                                                                _
                                LCD_CMD_PWCTR3,         2,  $0A, $00,                                                           _
                                LCD_CMD_PWCTR4,         2,  $8A, $2A,                                                           _
                                LCD_CMD_PWCTR5,         2,  $8A, $EE,                                                           _
                                LCD_CMD_VCOMCTR1,       1,  $0E
    TBL_End
$endif
'----------------------------------------------------------------------------


'----------------------------------------------------------------------------
$ifdef LCD_USE_TFT_096_80_160
    TBL_New(_TFT_096_80_160_)
        TBL_Raw(LCD_T_MAIN)     CData Word 80, Word 160, LCD_INI(1, 0, LCD_CAP_INVERSE)
        TBL_Raw(LCD_T_ROTN)     CData LCD__BGR,  LCD__MX | LCD__MV | LCD__BGR,  LCD__MX | LCD__MY | LCD__BGR,  LCD__MY | LCD__MV | LCD__BGR
        TBL_Raw(LCD_T_OFFS)     CData 26, 1,   1, 26,   26, 1,   1, 26
        TBL_Raw(LCD_T_LIST)     CData LCD_CMD_IDLEOF,   0,                                                                      _  ' Exit idle mode (ST7735S)
                                LCD_CMD_FRMCTR1,        3,  $01, $2C, $2D,                                                      _  ' Frame Rate Control (In normal mode)
                                'LCD_CMD_GAMMASET,      1,  $04,                                                                _  ' Default gamma curve?
                                'LCD_CMD_GAMRSEL,       1,  $01,                                                                _  ' Enable Gamma adj ?
                                LCD_CMD_PGAMMAC,       16,  $02,$1C,$07,$12,$37,$32,$29,$2D,$29,$25,$2B,$39,$00,$01,$03,$10,    _  ' Positive Gamma Correction Setting
                                LCD_CMD_NGAMMAC,       16,  $03,$1D,$07,$06,$2E,$2C,$29,$2D,$2E,$2E,$37,$3F,$00,$00,$02,$10,    _  ' Negative Gamma Correction Setting
                                LCD_CMD_DINVCTR,        1,  $07,                                                                _  ' Display inversion
                                LCD_CMD_NORML,          0,                                                                      _  ' Display Normal
                                LCD_CMD_PWCTR1,         3,  $A2, $02, $84,                                                      _  ' Power Control 1
                                LCD_CMD_PWCTR2,         1,  $C5,                                                                _  ' Power Control 2
                                LCD_CMD_PWCTR3,         2,  $0A, $00,                                                           _  ' Power Control 3
                                LCD_CMD_PWCTR4,         2,  $8A, $2A,                                                           _  ' Power Control 4
                                LCD_CMD_PWCTR5,         2,  $8A, $EE,                                                           _  ' Power Control 5
                                LCD_CMD_VCOMCTR1,       1,  $0E                                                                    ' VCOM control 1
    TBL_End
$endif
'----------------------------------------------------------------------------

  
'----------------------------------------------------------------------------
$ifdef LCD_USE_TFT_114_135_240
    TBL_New(_TFT_114_135_240_)
        TBL_Raw(LCD_T_MAIN)     CData Word 135, Word 240, LCD_INI(1, 0, 0)
        TBL_Raw(LCD_T_ROTN)     CData LCD__BGR,  LCD__MX | LCD__MV | LCD__BGR,  LCD__MX | LCD__MY | LCD__BGR,  LCD__MY | LCD__MV | LCD__BGR
        TBL_Raw(LCD_T_OFFS)     CData 52, 40,   40, 53,   53, 40,   40, 52
        TBL_Raw(LCD_T_LIST)     CData LCD_CMD_IDLEOF,   0,                                                                      _  ' Exit idle mode (ST7789V)
                                LCD_CMD_GCTRL,          1,  $35,                                                                _  ' Voltages: VGH / VGL
                                LCD_CMD_VCOMS,          1,  $28,                                                                _  ' JLX240 display datasheet
                                $B0,                    2,  $00, $E0,                                                           _
                                $B2,                    5,  $0C, $0C, $00, $33, $33,                                            _  ' Porch Setting
                                LCD_CMD_GAMMASET,       1,  $01,                                                                _  ' Default gamma curve?      
                                'LCD_CMD_PGAMMAC,      14,  $D0,$00,$02,$07,$0A,$28,$32,$44,$42,$06,$0E,$12,$14,$17,            _  ' Positive Gamma Correction Setting
                                'LCD_CMD_NGAMMAC,      14,  $D0,$00,$02,$07,$0A,$28,$31,$54,$47,$0E,$1C,$17,$1B,$1E,            _  ' Negative Gamma Correction Setting
                                LCD_CMD_NORML,          0,                                                                      _  ' Display Normal    
                                $C0,                    1,  $1C,                                                                _  ' LCM Control
                                $C2,                    2,  $01, $FF,                                                           _  ' VDV and VRH Enable
                                $C3,                    1,  $10,                                                                _  ' VRH Set
                                $C4,                    1,  $20,                                                                _  ' VDV Set
                                $C6,                    1,  $09,                                                                _  ' Frame Rate Control in Normal Mode
                                $D0,                    2,  $A4, $A1                                                               ' Power control 1
    TBL_End
$endif
'----------------------------------------------------------------------------


'----------------------------------------------------------------------------
$ifdef LCD_USE_TFT_130_240_240
    TBL_New(_TFT_130_240_240_)
        TBL_Raw(LCD_T_MAIN)     CData Word 240, Word 240, LCD_INI(0, 0, 0)
        TBL_Raw(LCD_T_ROTN)     CData LCD__BGR,  LCD__MX | LCD__MV | LCD__BGR,  LCD__MX | LCD__MY | LCD__BGR,  LCD__MY | LCD__MV | LCD__BGR
        TBL_Raw(LCD_T_OFFS)     CData 0, 0,   0, 0,   0, 80,   80, 0
        TBL_Raw(LCD_T_LIST)     CData LCD_CMD_IDLEOF,   0,                                                                      _  ' Exit idle mode (ST7789V)
                                LCD_CMD_GCTRL,          1,  $35,                                                                _  ' Voltages: VGH / VGL
                                LCD_CMD_VCOMS,          1,  $2B,                                                                _  ' JLX240 display datasheet
                                $B2,                    5,  $0C, $0C, $00, $33, $33,                                            _  ' Porch Setting
                                LCD_CMD_NORML,          0,                                                                      _  ' Display Normal    
                                $C0,                    1,  $1C,                                                                _  ' LCM Control
                                $C2,                    2,  $01, $FF,                                                           _  ' VDV and VRH Enable
                                $C3,                    1,  $11,                                                                _  ' VRH Set
                                $C4,                    1,  $20,                                                                _  ' VDV Set
                                $C6,                    1,  $0F,                                                                _  ' Frame Rate Control in Normal Mode
                                $D0,                    2,  $A4, $A1                                                               ' Power control 1
    TBL_End
$endif
'----------------------------------------------------------------------------


'----------------------------------------------------------------------------
Proc LCD_Select(value As WREG)
    If WREG <> 0 Then Lcd_ID = WREG

    TBLPTRA = 0

    ___($ifdef LCD_USE_TFT1_350_320_480)    ___(If Lcd_ID = LCD_TFT1_350_320_480  Then TBLPTRA = _TFT1_350_320_480_  :  ExitProc)    ___($endif)
    ___($ifdef LCD_USE_TFT2_350_320_480)    ___(If Lcd_ID = LCD_TFT2_350_320_480  Then TBLPTRA = _TFT2_350_320_480_  :  ExitProc)    ___($endif)
    ___($ifdef LCD_USE_TFT3_350_320_480)    ___(If Lcd_ID = LCD_TFT3_350_320_480  Then TBLPTRA = _TFT3_350_320_480_  :  ExitProc)    ___($endif)
    ___($ifdef LCD_USE_TFT_280_240_320)     ___(If Lcd_ID = LCD_TFT_280_240_320   Then TBLPTRA = _TFT_280_240_320_   :  ExitProc)    ___($endif)
    ___($ifdef LCD_USE_TFT_200_240_320)     ___(If Lcd_ID = LCD_TFT_200_240_320   Then TBLPTRA = _TFT_200_240_320_   :  ExitProc)    ___($endif)
    ___($ifdef LCD_USE_TFT_180_128_160)     ___(If Lcd_ID = LCD_TFT_180_128_160   Then TBLPTRA = _TFT_180_128_160_   :  ExitProc)    ___($endif)
    ___($ifdef LCD_USE_TFT_177_128_160)     ___(If Lcd_ID = LCD_TFT_177_128_160   Then TBLPTRA = _TFT_177_128_160_   :  ExitProc)    ___($endif)
    ___($ifdef LCD_USE_TFT_144_128_128)     ___(If Lcd_ID = LCD_TFT_144_128_128   Then TBLPTRA = _TFT_144_128_128_   :  ExitProc)    ___($endif)
    ___($ifdef LCD_USE_TFT_130_240_240)     ___(If Lcd_ID = LCD_TFT_130_240_240   Then TBLPTRA = _TFT_130_240_240_   :  ExitProc)    ___($endif)
    ___($ifdef LCD_USE_TFT_114_135_240)     ___(If Lcd_ID = LCD_TFT_114_135_240   Then TBLPTRA = _TFT_114_135_240_   :  ExitProc)    ___($endif)
    ___($ifdef LCD_USE_TFT_096_80_160 )     ___(If Lcd_ID = LCD_TFT_096_80_160    Then TBLPTRA = _TFT_096_80_160_    :  ExitProc)    ___($endif)
EndProc


'****************************************************************************
Over_LCD_TFT_DRV:

$endif
