'------------------------------- Use Displays -------------------------------
'$define LCD_USE_NOK5110
'$define LCD_USE_SH1106_128_64
'$define LCD_USE_SSD1306_128_64
'$define LCD_USE_ST7565
'$define LCD_USE_TFT_096_80_160
'$define LCD_USE_TFT_130_240_240
'$define LCD_USE_TFT_114_135_240
'$define LCD_USE_TFT_144_128_128
'$define LCD_USE_TFT_180_128_160
'$define LCD_USE_TFT_200_240_320
'$define LCD_USE_TFT_280_240_320
$define LCD_USE_TFT2_350_320_480


'-------------------------------- Interface ---------------------------------
' used for software Parallel 8 Bit
'$define LCD_RST     PORTD.7
'$define LCD_CS      PORTD.6
'$define LCD_DC      PORTD.5
'$define LCD_WR      PORTD.4
'$define LCD_RD      PORTC.7
'$define LCD_PORT    LATB

' used for software SPI
$define LCD_RST     PORTD.3
$define LCD_CS      PORTD.1
$define LCD_DC      PORTD.5
$define LCD_CLK     PORTD.0
$define LCD_DAT     PORTD.4

'$define LCD_CLK_HIGH        ' set for display 1.3 inches 240x240

' + used for hardware SPI 2
'$define LCD_IFC_Init()      SSP2CON1 = 0  :   SSP2ADD = BRT_(1000000)  :  SSP2STAT = %01000000  :  SSP2CON1 = %00101010  :  PIR3bits_SSP2IF = 1
'$define LCD_IFC_Speed()     If Lcd_Speed = 0 Then SSP2ADD = BRT_(1000000) : Else : SSP2ADD = BRT_(8000000)
'$define LCD_IFC_Wait()      Repeat  :  Until PIR3bits_SSP2IF = 1
'$define LCD_IFC_Write()     PIR3bits_SSP2IF = 0  :  SSP2BUF = WREG

' used for software I2C
'$define LCD_SCL     PORTD.0
'$define LCD_SDA     PORTD.4

' for CPU = 64 MHz:
' if this define then I2C clock (work) = 720 kHz  Else  = 470 kHz
' if this define then I2C clock (init) = 118 kHz  Else  = 109 kHz
'$define LCD__I2C_OverSpeed


'--------------------------------- Library ----------------------------------
Include "Lib\LCD\LCD_GFX.inc"
Include "Lib\LCD\Font\Std_5x8.inc"
Include "Lib\LCD\Font\SegoeUI_13x16.inc"
'Include "Lib\LCD\Image\Demo\moon_4.inc"
'Include "Lib\LCD\Image\Demo\icon_8.inc"


'----------------------------- Select Display -------------------------------
'LCD_Select(LCD_NOK5110)
'LCD_Select(LCD_SH1106_128_64)
'LCD_Select(LCD_SSD1306_128_64)
'LCD_Select(LCD_ST7565)
'LCD_Select(LCD_TFT_096_80_160)
'LCD_Select(LCD_TFT_130_240_240)
'LCD_Select(LCD_TFT_114_135_240)
'LCD_Select(LCD_TFT_144_128_128)
'LCD_Select(LCD_TFT_180_128_160)
'LCD_Select(LCD_TFT_200_240_320)
'LCD_Select(LCD_TFT_280_240_320)
LCD_Select(LCD_TFT1_350_320_480)


'------------------------------- Backlight --------------------------------
$define LCD_BackLight(P1)		LATC.1 =~ P1


'=================================== Code ===================================
GoTo Over_LCD_Test


Dim cntTest As Byte
Dim offset As Byte

$define DelayNextTest       LATD.2 = 1  :  LCD_Update()  :  DelayMS 1  :  Clrwdt  :  LATD.2 = 0


'----------------------------------------------------------------------------
Lcd_Test:

    DelayNextTest
      
    LCD_Clear()
    
    DelayNextTest
    
    
    LCD_TextColor( YELLOW, YELLOW )         ' draw font transparent if LCD_Forecolor = LCD_backcolor
    Lcd_Zoom = 1                            ' zoom for font
    
    LCD_Pos(4,24)
    LCD_SetFont(SegoeUI_13x16)
    Print "0123"
    
    LCD_Pos(64,20)
    Lcd_DrawChar(SegoeUI_13x16, 52)

    LCD_Pos(75,35)
    Lcd_DrawChar(SegoeUI_13x16, 53)
    
    
    DelayNextTest   
    

    LCD_SetFont(Std_5x8)

    LCD_Pos(6,4)
    For tmpB1 = 0 To 10
        LCD_Print(tmpB1 + offset)
    Next

    Print At 13,6, " Demo v", Dec DevMajor, ".", Dec DevMinor
    

    DelayNextTest


     LCD_Color = BLUE   :  LCD_Rect(0, 0, Lcd_Width, Lcd_Height)
     LCD_Color = RED    :  LCD_Rect(2, 2, Lcd_Width - 4, Lcd_Height - 4)


    DelayNextTest


     LCD_Color = LCD_RGB_565($00CCFF)   :  LCD_RectFill(10, 60, 50, 30)
     LCD_Color = GREEN                  :  LCD_CircleFill(96, 80, 24, 15)
     LCD_Color = RED                    :  LCD_RoundFill(16,130,80,50,10)

     LCD_Color = WHITE                  :  LCD_Rect(6, 56, 58, 38)
     LCD_Color = WHITE                  :  LCD_Circle(96, 80, 28, 15)
     LCD_Color = WHITE                  :  LCD_Round(12,126,88,58,13)
        
'    For tmpB1 = 0 To 127    
'    LCD_Clear()
'    LCD_Color = GREEN                  :  LCD_Rect(tmpB1 - 25, 10, 50, 30)
'    LCD_Color = BLUE                   :  LCD_Circle(tmpB1, 80, 25, 15)
'    DelayMS 50 : Clrwdt
'    Next
    
'    DelayMS 1000 : Clrwdt

'    For tmpB1 = 0 To 127    
'    LCD_Clear()
'    LCD_Color = GREEN                  :  LCD_RectFill(tmpB1 - 25, 10, 50, 30)
'    LCD_Color = BLUE                   :  LCD_CircleFill(tmpB1, 80, 25, 15)
'    DelayMS 50 : Clrwdt
'    Next
    
'    DelayNextTest
    
    'LCD_Clear()

'    DelayNextTest
    
    ' Dim tmpb3 As Byte

    ' For tmpB1 = 0  To 255
    '     LCD_Color.Byte0 = tmpB1
    '     LCD_Color.Byte1 = tmpB1
        
    '     tmpB2 = tmpB1 << 4
    '     tmpb3 = tmpB1 & 240

    '     LCD_RectFill(tmpB2 + 8, tmpb3 + 8, 14, 14)
    ' Next

    ' LCD_Color = WHITE                 :  LCD_Triangle(10,90, 60,90, 35,120)

     'LCD_Pos(0,0)
     'LCD_Image(moon_4)
     'LCD_Image(icon_8)

'    DelayNextTest
        
'    LCD_TextColor( GREEN, MAGENTA )
    
'    For tmpB1 = 0 To 127
'        LCD_Gradient(tmpB1 * 2)
'        LCD_Line(tmpB1,40,tmpB1,100)
'    Next

'    DelayNextTest
    
'    LCD_Clear()

'    For tmpB1 = 0 To 7
'        LCD_Color = LookUpL tmpB1, [BLACK, DARK_BLUE, DARK_GREEN, DARK_CYAN, DARK_RED, DARK_MAGENTA, DARK_YELLOW, GREY]
'        LCD_RectFill(tmpB1 * 14 + 8, 20, 10, 10)
'    Next

'    For tmpB1 = 0 To 7
'        LCD_Color = LookUpL tmpB1, [DARK_GREY, BLUE, GREEN, CYAN, RED, MAGENTA, YELLOW, WHITE]
'        LCD_RectFill(tmpB1 * 14 + 8, 40, 10, 10)
'    Next

'    DelayNextTest
    
    offset = offset + 11
Return



$define Oscil_SIZE      255
$define Oscil_KOEF      2

$define Oscil_ADC()     ADCON0.1 = 1  :  Repeat : Until ADCON0.1 = 0

Dim Oscil_Buf[Oscil_SIZE] As Byte Heap
Dim Oscil_Level As Byte


'----------------------------------------------------------------------------
Oscil_Update:
    'Oscil_Clear()
    LCD_Clear()
    
    Oscil_Channel(2)
    Oscil_Trigger()
    Oscil_Capture()    
    Oscil_Paint()
Return

'----------------------------------------------------------------------------
Proc Oscil_Clear()
    LCD_Color = BLACK
    Oscil_Paint()
EndProc

'----------------------------------------------------------------------------
Proc Oscil_Paint()
    Lfsr 0, (Oscil_Buf)  :  tmpW1 = 0  :  tmpW2 = Lcd_Height - 4
    
    tmpW3 = Tern(Lcd_Width > Oscil_SIZE, Oscil_SIZE, Lcd_Width)
    
    LCD_Color = GREEN
    
    PRODL = INDF0 / Oscil_KOEF  :  If PRODL > tmpW2 Then PRODL = tmpW2
    LCD_Pos(0, tmpW2 - PRODL)
    
    For tmpB1 = 0 To tmpW3 - 1   
        PRODL = POSTINC0
        tmpW1 = tmpW1 + PRODL
        PRODL = PRODL / Oscil_KOEF  :  If PRODL > tmpW2 Then PRODL = tmpW2
        LCD_LineTO(tmpB1, tmpW2 - PRODL)
    Next
    
    tmpB1 = tmpB1 / 4  :  tmpW1 = tmpW1 / tmpB1  :  Oscil_Level = tmpW1 / 4
   
    LCD_TextColor( YELLOW, YELLOW )  :  Print At 2,2, "mV = ", Dec tmpW1

    LCD_Update()
EndProc

'----------------------------------------------------------------------------
Proc Oscil_Channel(value As PRODL)
    'ANSELA.2 = 1  :  TRISA.2 = 1  ' channel = 2
    'ANSELB.3 = 1  :  TRISB.3 = 1  ' channel = 9

    ADCON2 = %00000010  :  ADCON1 = %00001000  :  VREFCON0 = %10010000

    WREG = value << 2  :  ADCON0 = WREG | 1
EndProc

'----------------------------------------------------------------------------
Proc Oscil_Trigger()
    PL1 = 0      
    For PRODH = 3 To 0 Step -1 
        For PRODL = 255 To 0 Step -1  
            Oscil_ADC()
            If ADRESH < Oscil_Level Then PL1 = 1
            If PL1 = 1 Then If ADRESH > Oscil_Level Then Return
        Next
    Next
EndProc

'----------------------------------------------------------------------------
Proc Oscil_Capture()
    Lfsr 0, (Oscil_Buf)
    For PRODL = Oscil_SIZE - 1 To 0 Step -1
        Oscil_ADC()
        POSTINC0 = ADRESH
    Next
EndProc



$ifndef Logic_Port
$define Logic_Port()        PORTA
$endif

$ifndef Logic_Delay
$define Logic_Delay()       0
$endif

'----------------------------------------------------------------------------
Logic_Update:
    PROD = 2500  :  Lcd_Tmp = Logic_Port
    Repeat
       	If Lcd_Tmp < Logic_Port Then Break
        Lcd_Tmp = Logic_Port
        Dec PROD
    Until PROD = 0
    
    Lfsr 0, (Oscil_Buf)  :  tmpW2 = Lcd_Height - 4  :  PB3 = tmpW2 / 8  :  PB2 = PB3 */ 210

    tmpW3 = Tern(Lcd_Width > Oscil_SIZE, Oscil_SIZE, Lcd_Width)

    For PRODL = Oscil_SIZE - 1 To 0 Step -1
       	POSTINC0 = Logic_Port  :  DelayUS Logic_Delay
    Next
    
    LCD_Clear()
    
    For tmpB2 = 0 To 7

        Lfsr 0, (Oscil_Buf)

        Lcd_X = 0  :  WREG = 0  :  If INDF0.0 = 1 Then WREG = PB2
        Lcd_Y = tmpW2 - WREG
    
        LCD_Color = GREEN

        For tmpB1 = 0 To tmpW3 - 1    
            Lcd_X2 = tmpB1  :  WREG = 0  :  If INDF0.0 = 1 Then WREG = PB2
            Lcd_Y2 = tmpW2 - WREG
            LCD_LineTO(Lcd_X2, Lcd_Y2)
            Rrncf POSTINC0,F,0
        Next

        LCD_Color = GREY

        Lcd_Y = tmpW2
        For Lcd_X = 0 To Lcd_Width - 1 Step 4
            LCD_Pixel()
        Next
        
        tmpW2 = tmpW2 - PB3
    Next

    LCD_Update()
Return



'============================================================================
Over_LCD_Test:

LCD_Init()  :  offset = 32  :  GoSub Lcd_Test  :  DelayMS 2000  :  Clrwdt
